	// Alter these as needed
	var cellWidth         = 256; // The width, in px, of your image cell
	var cellHeight        = 256; // The height, in px, of your image cell
	var xOffset           = 0; // The space, in px, between each cell in a row
	var yOffset           = 0; // The space, in px, between each row. Set to 0 for traditional checker board effect
	var options           = new ExportOptionsSaveForWeb();
		options.format    = SaveDocumentType.JPEG;
		options.quality   = 100;

	// Don't change these unless you know why you should! :)
	var doc               = app.activeDocument;
	var dname             = doc.name.substr(0,doc.name.length-4);
	var dir               = doc.path.toString()+"/";
	var rowShift          = true;
	var imageWidth        = activeDocument.width.as('px');
	var imageHeight       = activeDocument.height.as('px');


	function main() {

		if (imageWidth != 56064 & imageWidth != 28160 & imageWidth != 14080 & imageWidth != 7168 & imageWidth != 3584 & imageWidth != 1792 & imageWidth != 1024 & imageWidth != 512 & imageWidth != 256) {
			alert ("Invalid file size - expected width of 56064 (level 4), 28160 (level 3), 14080 (level 2), 7168 (level 1), 3584 (level 0), 1792 (level -1), 1024 (level -2), 512 (level -3) or 256 (level -4)");
			return;
		}
		//else {
			//before tiling commences crop down image to bounds for zoomed in images, or visible area for those where the monitor screen may show more than the bounds
			//if (imageHeight == 56064) {
			//	doc.resizeCanvas(48384, 20480, AnchorPosition.MIDDLECENTER);
			//}
			//else {
			//}
		//}
	}

	function sub() {

	// Store the current rulerUnits for later. We're going to change
	// it to pixels for now, and we want to change it back later.
	var myRulerUnits = app.preferences.rulerUnits;

	// Set rulerUnits to pixels
	app.preferences.rulerUnits = Units.PIXELS;

	// Find the "Background"
	var layerRef = doc.artLayers.getByName("Background");

	// Set our "Background" to be a Layer
	layerRef.isBackgroundLayer = false;

	// Reduce the Canvas size to our cell size
	doc.resizeCanvas(cellWidth, cellHeight, AnchorPosition.TOPLEFT);

	var totalOffset = 0;
	var xMovement = 0;

	// Do the magic
	for (var y = 0; y < numberOfRows(); y++)
	{
		totalOffset = 0;

		for (var x = 0; x < numberOfCells(); x++)
		{
			if (x == 0)
			{
				xMovement = (rowShift) ? xOffset : 0;
			}
			else
			{
				xMovement = cellWidth + xOffset;
			}

			totalOffset += xMovement;

			// Offset the layer into our Canvas "window"
			layerRef.applyOffset(-(xMovement), 0, OffsetUndefinedAreas.WRAPAROUND);

			saveCell(x,y);
		};

		// Offset the layer back to the left and down one row
		layerRef.applyOffset(totalOffset, -(cellHeight + yOffset), OffsetUndefinedAreas.WRAPAROUND);

		// Flip the rowShift. If it was true, make it false and vice versa.
		rowShift = !rowShift;
	};

	// Pad the cell x and y numbers for proper sorting
	/* function pad(num, size)
	{
		var s = "000000000" + num;
		return s.substr(s.length-size);
	} */

	// Reset the ruler units
	app.preferences.rulerUnits = myRulerUnits;

	};

function app2() { 
	main();

	var imageWidth        = activeDocument.width.as('px');
	var imageHeight       = activeDocument.height.as('px');

	sub();
	
}  
  
app.activeDocument.suspendHistory ("Swing", "app2()");  

	// Calculate number of cells per row. May change depending on rowShift, etc
	function numberOfCells()
	{
		var theWidth = imageWidth;

		if (rowShift == true)
		{
			var theWidth = theWidth - xOffset; 
		}
		return Math.floor((theWidth + xOffset) / (cellWidth + xOffset));
	}

	// Calculate number of rows
	function numberOfRows()
	{
		return Math.floor((imageHeight + yOffset) / (cellHeight + yOffset));
	}

	// Actually save, or really "Save For Web" the cell
	function saveCell(x, y)
	{
		if (imageWidth == 56064) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/4/";
		}
		if (imageWidth == 28160) {
			var ycoordAdjust = 0; 
			var xcoordAdjust = 0;
			var directory = "/3/";
		}
		if (imageWidth == 14080) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/2/";
		}
		if (imageWidth == 7168) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/1/";
		}
		if (imageWidth == 3584) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/0/";
		}
		if (imageWidth == 1792) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/-1/";
		}
		if (imageWidth == 1024) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/-2/";
		}
		if (imageWidth == 512) {
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/-3/";
		}
		if (imageWidth == 256) {		
			var ycoordAdjust = 0;
			var xcoordAdjust = 0;
			var directory = "/-4/";
		}

		var ycoordOffset = Math.floor((imageHeight) / (cellHeight)); 
		var ycoordMidpoint = Math.floor((imageHeight - ycoordAdjust) / (cellHeight));
		
		var xcoordOffset = Math.floor((imageWidth) / (cellWidth)); 
		var xcoordMidpoint = Math.floor(xcoordAdjust / (cellWidth));
		
		var ycoord = y - ycoordOffset + (ycoordOffset - ycoordMidpoint);
		var xcoord = x - xcoordMidpoint;
		
		//var nname =  "map-" + pad((x + 1), 3) + "_" + pad((y + 1), 3);
		var nname =  "map_" + ycoord + "_" + xcoord;

		doc.exportDocument (new File(dir + "../../../Git/40kmap-v4/images/map-tiles" + directory + "" + nname + ".jpg"), ExportType.SAVEFORWEB, options);
	}